char *
__b2c__chop (char *source, char *string, int location)
{
  char *tmp;
  long length, idx;
  if (source == NULL || *source == '\0')
    {
      return (source);
    }
  if (string == NULL)
    {
      string = (char *) __b2c__chop_default;
    }
  length = __b2c__len (string);
  if (location == 0 || location == 1)
    {
      while (*source != '\0')
	{
	  if (memchr (string, *source, length))
	    {
	      source++;
	    }
	  else
	    {
	      break;
	    }
	}
      if (*source == '\0')
	{
	  return (EmptyString);
	}
    }
  tmp = source + strlen (source) - 1;
  if (location == 0 || location == 2)
    {
      while (tmp >= source && *tmp != '\0')
	{
	  if (memchr (string, *tmp, length))
	    {
	      tmp--;
	    }
	  else
	    {
	      break;
	    }
	}
    }
  tmp++;
  idx = __sbuf_malloc_handle (tmp - source + 1);
  memmove (__b2c__sbuffer[idx], source, tmp - source);
  __b2c__SETLEN (__b2c__sbuffer[idx], tmp - source);
  __b2c__sbuffer[idx][tmp - source] = '\0';
  return (char *) (__b2c__sbuffer[idx]);
}

char *
__b2c__asc2char (int i)
{
  long idx;
  int len;
  idx = __sbuf_malloc_handle (2);
  len = snprintf (__b2c__sbuffer[idx], 2, "%c", i);
  __b2c__SETLEN (__b2c__sbuffer[idx], len);
  return (char *) (__b2c__sbuffer[idx]);
}

char *
__b2c__asc2utf8 (int i)
{
  long idx;
  int len;
  char buf[5];
  len = __b2c_utf8_conv (i, buf);
  idx = __sbuf_malloc_handle (len + 1);
  memcpy (__b2c__sbuffer[idx], buf, len);
  __b2c__SETLEN (__b2c__sbuffer[idx], len);
  __b2c__sbuffer[idx][len] = '\0';
  return (char *) (__b2c__sbuffer[idx]);
}

unsigned int
__b2c__utf8toasc (char *ptr)
{
  unsigned int result = 0;
  if ((*ptr & 0xF0) == 0xF0)
    {
      result = (*ptr & 0x07) << 2;
      ptr++;
      result = result | ((*ptr & 0x30) >> 4);
      result = result << 8;
      result = result | ((*ptr & 0x0F) << 4);
      ptr++;
      result = result | ((*ptr & 0x3C) >> 2);
      result = result << 8;
      result = result | ((*ptr & 0x03) << 6);
      ptr++;
      result = result | (*ptr & 0x3F);
    }
  else if ((*ptr & 0xE0) == 0xE0)
    {
      result = (*ptr & 0x0F) << 4;
      ptr++;
      result = result | ((*ptr & 0x3C) >> 2);
      result = result << 8;
      result = result | ((*ptr & 0x03) << 6);
      ptr++;
      result = result | (*ptr & 0x3F);
    }
  else if ((*ptr & 0xC0) == 0xC0)
    {
      result = (*ptr & 0x1C) >> 2;
      result = result << 8;
      result = result | ((*ptr & 0x03) << 6);
      ptr++;
      result = result | (*ptr & 0x3F);
    }
  else if ((*ptr & 0x80) == 0)
    {
      result = (*ptr & 0x7F);
    }
  return (result);
}

unsigned char
__b2c__isascii (const char *ptr)
{
  long x;
  for (x = 0; *(ptr + x); x++)
    {
      if (*(ptr + x) & 128)
	return (0);
    }
  return (1);
}

unsigned char
__b2c__isutf8 (const char *ptr)
{
  int result = 1;
  if (ptr == NULL)
    {
      return (0);
    }
  while (*ptr)
    {
      if ((*ptr & 0xF0) == 0xF0)
	{
	  if ((*(ptr + 1) & 0xC0) != 0x80 || (*(ptr + 2) & 0xc0) != 0x80
	      || (*(ptr + 3) & 0xc0) != 0x80)
	    {
	      result = 0;
	      break;
	    }
	  ptr += 4;
	}
      else if ((*ptr & 0xE0) == 0xE0)
	{
	  if ((*(ptr + 1) & 0xc0) != 0x80 || (*(ptr + 2) & 0xc0) != 0x80)
	    {
	      result = 0;
	      break;
	    }
	  ptr += 3;
	}
      else if ((*ptr & 0xC0) == 0xC0)
	{
	  if ((*(ptr + 1) & 0xc0) != 0x80)
	    {
	      result = 0;
	      break;
	    }
	  ptr += 2;
	}
      else if ((*ptr & 0x80) == 0)
	{
	  ptr++;
	}
      else
	{
	  result = 0;
	  break;
	}
    }
  return (result);
}

char *
__b2c__toascii (char *ptr)
{
  int len, x;
  len = __b2c__len (ptr);
  for (x = 0; x < len; x++)
    {
      *(ptr + x) = *(ptr + x) & 0x7f;
    }
  return (ptr);
}

char *
__b2c__concat (int n, ...)
{
  long length = 0, cnew, idx;
  char *next;
  va_list ap;
  if (n == 0)
    {
      return (EmptyString);
    }
  idx = __sbuf_malloc_handle (sizeof (char));
  va_start (ap, n);
  while (n)
    {
      next = va_arg (ap, char *);
      if (next)
	{
	  cnew = __b2c__len (next);
	  __sbuf_need_realloc (idx, length + cnew + 1);
	  memmove (__b2c__sbuffer[idx] + length, next, cnew);
	  length += cnew;
	}
      n--;
    }
  va_end (ap);
  __b2c__SETLEN (__b2c__sbuffer[idx], length);
  __b2c__sbuffer[idx][length] = '\0';
  return ((char *) __b2c__sbuffer[idx]);
}

long
__b2c__count (int l, char *k, char *x, unsigned int y)
{
  long i, z = 0;
  if (__b2c__option_utf8)
    {
      while (*x)
	{
	  if (__b2c__utf8toasc (x) == y)
	    {
	      z++;
	    }
	  if ((*x & 0xF0) == 0xF0)
	    {
	      x += 4;
	    }
	  else if ((*x & 0xE0) == 0xE0)
	    {
	      x += 3;
	    }
	  else if ((*x & 0xC0) == 0xC0)
	    {
	      x += 2;
	    }
	  else if ((*x & 0x80) == 0)
	    {
	      x++;
	    }
	  else
	    {
	      ERROR = 38;
	      RUNTIMEFERR ("COUNT", ERROR, k, l);
	    }
	}
    }
  else
    {
      for (i = 0; x[i] != '\0'; i++)
	{
	  if (x[i] == y)
	    {
	      z++;
	    }
	}
    }
  return z;
}

uint64_t
__b2c__hex2dec (int l, char *k, char *h, int flag)
{
  uint64_t j = 0;
  char *status = NULL;
  if (h == NULL)
    {
      return (0);
    }
  if (flag == 1)
    {
      flag = 2;
    }
  else if (flag > 36)
    {
      ERROR = 5;
      RUNTIMEFERR ("DEC", ERROR, k, l);
    }
  if (flag == 0)
    {
      j = strtol (h, &status, 16);
      if (*status != '\0' && __b2c__trap)
	{
	  ERROR = 5;
	  RUNTIMEFERR ("DEC", ERROR, k, l);
	}
    }
  else
    {
      j = strtol (h, &status, flag);
      if (*status != '\0')
	{
	  ERROR = 5;
	  RUNTIMEFERR ("DEC", ERROR, k, l);
	}
    }
  return (uint64_t) (j);
}

char *
ERR__b2c__string_var (int nr)
{
  switch (nr)
    {
    case 0:
      strcpy (__b2c__warn, "Success");
      break;
    case 1:
      strcpy (__b2c__warn, "Trying to access illegal memory: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 2:
      strcpy (__b2c__warn, "Error opening file: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 3:
      strcpy (__b2c__warn, "Could not open library.");
      break;
    case 4:
      strcpy (__b2c__warn, "Symbol not found in library.");
      break;
    case 5:
      strcpy (__b2c__warn, "Wrong value: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 6:
      strcpy (__b2c__warn, "Unable to claim memory.");
      break;
    case 7:
      strcpy (__b2c__warn, "Unable to delete file: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 8:
      strcpy (__b2c__warn, "Could not open directory: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 9:
      strcpy (__b2c__warn, "Unable to rename file: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 10:
      strcpy (__b2c__warn,
	      "NETWORK argument should contain colon with port number");
      break;
    case 11:
      strcpy (__b2c__warn, "Could not resolve hostname!");
      break;
    case 12:
      strcpy (__b2c__warn, "Socket error: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 13:
      strcpy (__b2c__warn, "Unable to open address: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 14:
      strcpy (__b2c__warn, "Error reading from socket: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 15:
      strcpy (__b2c__warn, "Error sending to socket: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 16:
      strcpy (__b2c__warn, "Error checking socket: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 17:
      strcpy (__b2c__warn, "Unable to bind the specified socket address: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 18:
      strcpy (__b2c__warn, "Unable to listen to socket address: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 19:
      strcpy (__b2c__warn, "Cannot accept incoming connection: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 20:
      strcpy (__b2c__warn, "Unable to remove directory: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 21:
      strcpy (__b2c__warn, "Unable to create directory: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 22:
      strcpy (__b2c__warn, "Unable to change to directory: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 23:
      strcpy (__b2c__warn,
	      "GETENVIRON argument does not exist as environment variable");
      break;
    case 24:
      strcpy (__b2c__warn, "Unable to stat file: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 25:
      strcpy (__b2c__warn, "Search contains illegal string");
      break;
    case 26:
      strcpy (__b2c__warn, "Cannot return name: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 27:
      strcpy (__b2c__warn, "Illegal regex expression");
      break;
    case 28:
      strcpy (__b2c__warn, "Unable to create bidirectional pipes: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 29:
      strcpy (__b2c__warn, "Unable to fork process: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 30:
      strcpy (__b2c__warn, "Cannot read from pipe: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 31:
      strcpy (__b2c__warn, "Gosub nesting too deep!");
      break;
    case 32:
      strcpy (__b2c__warn, "Could not open device: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 33:
      strcpy (__b2c__warn, "Error configuring serial port: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 34:
      strcpy (__b2c__warn, "Error accessing device: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 35:
      strcpy (__b2c__warn, "Error in INPUT: ");
      strncat (__b2c__warn, strerror (errno), 464);
      break;
    case 36:
      strcpy (__b2c__warn, "Illegal value in SORT dimension!");
      break;
    case 37:
      strcpy (__b2c__warn, "Illegal option for SEARCH!");
      break;
    case 38:
      strcpy (__b2c__warn, "Invalid UTF8 string!");
      break;
    case 39:
      strcpy (__b2c__warn, "Illegal EVAL expression!");
      break;
    case 40:
      strcpy (__b2c__warn, "SSL file descriptor error!");
      break;
    case 41:
      strcpy (__b2c__warn, "SSL file descriptor pool exhausted!");
      break;
    case 42:
      strcpy (__b2c__warn, "Widget not found!");
      ERROR = 42;
      break;
    case 43:
      strcpy (__b2c__warn, "Unsupported array type!");
      break;
    };
  ERROR = 0;
  return (__b2c__warn);
}

static char **
__b2c__Get_Args (char *line)
{
  char **ptr = NULL;
  char *arg;
  int in_string = 0, x = 0;
  arg = line;
  while (*line != '\0')
    {
      switch (*line)
	{
	case 34:
	  in_string = 1 - in_string;
	  line++;
	  break;
	case 32:
	  if (!in_string)
	    {
	      ptr = (char **) realloc (ptr, (x + 1) * sizeof (char *));
	      if (*arg == 34)
		arg++;
	      if (*(line - 1) == 34)
		line--;
	      ptr[x] = __b2c__strndup (arg, line - arg);
	      while (isspace (*line) && *line != '\0')
		{
		  line++;
		}
	      arg = line;
	      x++;
	    }
	  else
	    {
	      line++;
	    }
	  break;
	default:
	  line++;
	}
    }
  ptr = (char **) realloc (ptr, (x + 2) * sizeof (char *));
  if (*arg == 34)
    arg++;
  if (*(line - 1) == 34)
    line--;
  ptr[x] = __b2c__strndup (arg, line - arg);
  ptr[x + 1] = NULL;
  return (ptr);
}

char *
__b2c__exec (int t, int l, char *k, char *cmd, char *str, int out)
{
  int forking, length, dnull;
  ssize_t result = 0;
  int wpipe[2], rpipe[2];
  char **args;
  char *ans = NULL;
  long idx;
  idx = __sbuf_malloc_handle (sizeof (char));
  if (pipe (rpipe) < 0 || pipe (wpipe) < 0)
    {
      if (__b2c__trap)
	{
	  ERROR = 29;
	  RUNTIMEFERR ("EXEC$", ERROR, k, l);
	}
    }
  if ((forking = fork ()) < 0)
    {
      if (__b2c__trap)
	{
	  ERROR = 29;
	  RUNTIMEFERR ("EXEC$", ERROR, k, l);
	}
    }
  else if (forking == 0)
    {
      fflush (stdout);
      close (wpipe[1]);
      close (rpipe[0]);
      dup2 (wpipe[0], STDIN_FILENO);
      close (wpipe[0]);
      dnull = open ("/dev/null", O_RDWR);
      if (out == 1)
	{
	  dup2 (rpipe[1], STDOUT_FILENO);
	  dup2 (dnull, STDERR_FILENO);
	}
      else if (out == 2)
	{
	  dup2 (dnull, STDOUT_FILENO);
	  dup2 (rpipe[1], STDERR_FILENO);
	}
      else
	{
	  dup2 (rpipe[1], STDOUT_FILENO);
	  dup2 (rpipe[1], STDERR_FILENO);
	}
      close (rpipe[1]);
      if (t == 0)
	{
	  forking = system (cmd);
	  if (WIFEXITED (forking))
	    result = WEXITSTATUS (forking);
	}
      else
	{
	  args = __b2c__Get_Args (cmd);
	  if (execvp (args[0], args) < 0)
	    {
	      if (__b2c__trap)
		{
		  ERROR = 29;
		  RUNTIMEFERR ("EXEC$", ERROR, k, l);
		}
	    }
	}
      close (dnull);
      _exit (result);
    }
  else
    {
      close (wpipe[0]);
      close (rpipe[1]);
      ans = (char *) malloc (512);
      length = 0;
      if (str != NULL)
	result = write (wpipe[1], str, __b2c__len (str));
      close (wpipe[1]);
      do
	{
	  result = read (rpipe[0], ans, 512);
	  if (result == -1 && __b2c__trap)
	    {
	      ERROR = 30;
	      RUNTIMEFERR ("EXEC$", ERROR, k, l);
	    }
	  if (result == 0)
	    break;
	  __sbuf_need_realloc (idx, length + result + 1);
	  if (__b2c__sbuffer[idx] == NULL && __b2c__trap)
	    {
	      ERROR = 6;
	      RUNTIMEFERR ("EXEC$", ERROR, k, l);
	    }
	  memcpy (__b2c__sbuffer[idx] + length, ans, (size_t) labs (result));
	  length += result;
	}
      while (result > 0);
      __b2c__SETLEN (__b2c__sbuffer[idx], length);
      __b2c__sbuffer[idx][length] = '\0';
      close (rpipe[0]);
      free (ans);
      wait (&RETVAL);
      RETVAL = WEXITSTATUS (RETVAL);
    }
  return (char *) (__b2c__sbuffer[idx]);
}

uint64_t
__b2c__HashFNV1a (const char *key, int len)
{
  uint64_t hash = 14695981039346656037UL;
  if (key == NULL)
    {
      return (0);
    }
  if (len)
    {
      while (len)
	{
	  hash = 1099511628211 * (hash ^ *key);
	  key++;
	  len--;
	}
    }
  else
    {
      while (*key)
	{
	  hash = 1099511628211 * (hash ^ *key);
	  key++;
	}
    }
  return (hash);
}

__b2c__htable *
__b2c__hash_new ()
{
  __b2c__htable *name;
  name = (__b2c__htable *) calloc (1, sizeof (__b2c__htable));
  name->next = NULL;
  name->total = 0;
  return (name);
}

__b2c__htable *
__b2c__hash_find_key_do (__b2c__htable * name, unsigned short hash, char *key)
{
  if (key == NULL || name == NULL)
    {
      return (NULL);
    }
  if (hash == 0)
    {
      hash = HASH (key) & 65535;
    }
  do
    {
      if (name->key[hash] == NULL)
	{
	  return (NULL);
	}
      else if (!strcmp (name->key[hash], key))
	{
	  return (name);
	}
      name = name->next;
    }
  while (name);
  return (NULL);
}

#define __b2c__hash_find_key(x, y, ...) __b2c__hash_find_key_do(x, y, __b2c__KEYCOLLECT(__VA_ARGS__))
void *
__b2c__hash_find_value_do (__b2c__htable * name, char *key)
{
  __b2c__htable *table;
  unsigned short pos;
  if (name == NULL || key == NULL)
    {
      return (NULL);
    }
  pos = HASH (key) & 65535;
  table = __b2c__hash_find_key (name, pos, key);
  if (table)
    {
      return (table->value[pos]);
    }
  return (NULL);
}

#define __b2c__hash_find_value(x, ...) __b2c__hash_find_value_do(x, __b2c__KEYCOLLECT(__VA_ARGS__))
void
__b2c__hash_add_do (__b2c__htable * name, const void *value, int flag,
		    const char *key)
{
  __b2c__htable *orig;
  unsigned short hash;
  if (name == NULL || key == NULL)
    {
      return;
    }
  orig = name;
  hash = HASH (key) & 65535;
  while (1)
    {
      if (name->key[hash] == NULL)
	{
	  orig->total++;
	  break;
	}
      if (!strcmp (name->key[hash], key))
	{
	  break;
	}
      if (name->next)
	{
	  name = name->next;
	}
      else
	{
	  name->next = __b2c__hash_new ();
	  name = name->next;
	}
    }
  if (!name->key[hash])
    {
      name->key[hash] = strdup (key);
    }
  if (flag == 0)
    {
      name->value[hash] = realloc (name->value[hash], sizeof (void *));
      memcpy (name->value[hash], value, sizeof (void *));
    }
  else
    {
      name->value[hash] =
	realloc (name->value[hash], strlen ((char *) value) + 1);
      strcpy ((char *) name->value[hash], (const char *) value);
}}

#define __b2c__hash_add(x, y, ...) __b2c__hash_add_do(x, y, 0, __b2c__KEYCOLLECT(__VA_ARGS__))
#define __b2c__hash_add_str(x, y, ...) __b2c__hash_add_do(x, y, 1, __b2c__KEYCOLLECT(__VA_ARGS__))
void
__b2c__hash_del_do (__b2c__htable * name, char *key)
{
  __b2c__htable *found;
  unsigned short pos;
  if (name == NULL)
    {
      return;
    }
  pos = HASH (key) & 65535;
  found = __b2c__hash_find_key (name, pos, key);
  if (found)
    {
      free (found->key[pos]);
      found->key[pos] = NULL;
      if (found->value[pos])
	{
	  free (found->value[pos]);
	}
      found->value[pos] = NULL;
      name->total--;
    }
}

#define __b2c__hash_del(x, ...) __b2c__hash_del_do(x, __b2c__KEYCOLLECT(__VA_ARGS__))
void
__b2c__hash_clear_do (__b2c__htable * name)
{
  __b2c__htable *next;
  int i;
  while (name)
    {
      for (i = 0; i < 65536; i++)
	{
	  if (name->key[i])
	    {
	      free (name->key[i]);
	    }
	  name->key[i] = NULL;
	  if (name->value[i])
	    {
	      free (name->value[i]);
	    }
	  name->value[i] = NULL;
	}
      next = name->next;
      free (name);
      name = next;
    }
}

#define __b2c__hash_clear(x) __b2c__hash_clear_do(x); x = NULL
char *
__b2c__hash_obtain (__b2c__htable * name, char *delim)
{
  long idx, ctr, dlen, len, items, total = 0;
  if (name == NULL)
    {
      return (EmptyString);
    }
  if (delim == NULL)
    {
      delim = __b2c__option_delim;
    }
  items = name->total;
  if (items == 0)
    {
      return (EmptyString);
    }
  dlen = __b2c__len (delim);
  idx = __sbuf_malloc_handle (dlen);
  do
    {
      for (ctr = 0; ctr < 65536; ctr++)
	{
	  if (name->key[ctr])
	    {
	      len = __b2c__len (name->key[ctr]);
	      __sbuf_need_realloc (idx, total + len + dlen);
	      memmove (__b2c__sbuffer[idx] + total, name->key[ctr], len);
	      total += len;
	      items--;
	      if (items > 0)
		{
		  memmove (__b2c__sbuffer[idx] + total, delim, dlen);
		  total += dlen;
		}
	    }
	}
      name = name->next;
    }
  while (name);
  __b2c__SETLEN (__b2c__sbuffer[idx], total);
  __b2c__sbuffer[idx][total] = '\0';
  return ((char *) __b2c__sbuffer[idx]);
}

char *
__b2c__hash_obtain_by_sort (int l, char *k, __b2c__htable * name, char *delim,
			    int up_down, int type)
{
  void **values = { NULL };
  __b2c__htable *ptr;
  int i, j, pos = 0;
  long idx, dlen, len, total = 0;
  if (name == NULL || name->total == 0)
    {
      return (EmptyString);
    }
  if (delim == NULL)
    {
      delim = __b2c__option_delim;
    }
  values = (void **) calloc (name->total, sizeof (char *));
  ptr = name;
  do
    {
      for (i = 0; i < 65536; i++)
	{
	  if (ptr->key[i])
	    {
	      values[pos++] = ptr->value[i];
	    }
	}
      ptr = ptr->next;
    }
  while (ptr);
  switch (type)
    {
    case 0:
      if (up_down)
	{
	  qsort (&values[0], pos, sizeof (void *), __b2c__sortstr);
	}
      else
	{
	  qsort (&values[0], pos, sizeof (void *), __b2c__sortstr_down);
	} break;
    case 1:
      if (up_down)
	{
	  qsort (&values[0], pos, sizeof (void *), __b2c__sortnrd_wrap);
	}
      else
	{
	  qsort (&values[0], pos, sizeof (void *), __b2c__sortnrd_wrap_down);
	} break;
    case 2:
      if (up_down)
	{
	  qsort (&values[0], pos, sizeof (void *), __b2c__sortnrf_wrap);
	}
      else
	{
	  qsort (&values[0], pos, sizeof (void *), __b2c__sortnrf_wrap_down);
	} break;
    case 3:
      if (up_down)
	{
	  qsort (&values[0], pos, sizeof (void *), __b2c__sortnrl_wrap);
	}
      else
	{
	  qsort (&values[0], pos, sizeof (void *), __b2c__sortnrl_wrap_down);
	} break;
    case 4:
      if (up_down)
	{
	  qsort (&values[0], pos, sizeof (void *), __b2c__sortnri_wrap);
	}
      else
	{
	  qsort (&values[0], pos, sizeof (void *), __b2c__sortnri_wrap_down);
	} break;
    case 5:
      if (up_down)
	{
	  qsort (&values[0], pos, sizeof (void *), __b2c__sortnrs_wrap);
	}
      else
	{
	  qsort (&values[0], pos, sizeof (void *), __b2c__sortnrs_wrap_down);
	} break;
    case 6:
      if (up_down)
	{
	  qsort (&values[0], pos, sizeof (void *), __b2c__sortnrc_wrap);
	}
      else
	{
	  qsort (&values[0], pos, sizeof (void *), __b2c__sortnrc_wrap_down);
	} break;
    default:
      if (__b2c__trap)
	{
	  ERROR = 43;
	  RUNTIMEFERR ("OBTAIN$", ERROR, k, l);
	}
    }
  dlen = __b2c__len (delim);
  idx = __sbuf_malloc_handle (dlen);
  for (j = 0; j < pos; j++)
    {
      ptr = name;
      do
	{
	  for (i = 0; i < 65536; i++)
	    {
	      if (type ==
		  0 ? !__b2c__strcmp ((const char *) ptr->value[i],
				      (const char *) values[j]) :
		  !__b2c__memcmp (ptr->value[i], values[j]))
		{
		  len = __b2c__len (ptr->key[i]);
		  __sbuf_need_realloc (idx, total + len + dlen);
		  memmove (__b2c__sbuffer[idx] + total, ptr->key[i], len);
		  total += len;
		  if (j < pos - 1)
		    {
		      memmove (__b2c__sbuffer[idx] + total, delim, dlen);
		      total += dlen;
		    }
		  if (j + 1 < pos
		      && (type ==
			  0 ? !__b2c__strcmp ((const char *) values[j],
					      (const char *) values[j +
								    1]) :
			  !__b2c__memcmp (values[j], values[j + 1])))
		    {
		      j++;
		    }
		  else
		    {
		      ptr = NULL;
		      break;
		    }
		}
	    }
	  if (ptr)
	    {
	      ptr = ptr->next;
	    }
	}
      while (ptr);
    }
  free (values);
  __b2c__SETLEN (__b2c__sbuffer[idx], total);
  __b2c__sbuffer[idx][total] = '\0';
  return ((char *) __b2c__sbuffer[idx]);
}

void
__b2c__hash_dup_do (__b2c__htable * from, __b2c__htable * to, int flag)
{
  int i;
  char *value;
  while (from)
    {
      for (i = 0; i < 65536; i++)
	{
	  if (from->key[i])
	    {
	      value = (char *) __b2c__hash_find_value (from, from->key[i]);
	      if (flag == 0)
		{
		  __b2c__hash_add (to, value, from->key[i]);
		}
	      else
		{
		  __b2c__hash_add_str (to, value, from->key[i]);
		}
	    }
	}
      from = from->next;
      if (to->next == NULL)
	{
	  to->next = __b2c__hash_new ();
	}
      to = to->next;
    }
}

#define __b2c__hash_dup(x, y) __b2c__hash_dup_do(x, y, 0)
#define __b2c__hash_dup_str(x, y) __b2c__hash_dup_do(x, y, 1)
char *
__b2c__hash_key_collect (int n, ...)
{
  long length = 0, cnew, idx;
  char *next;
  va_list ap;
  if (n == 0)
    {
      return (EmptyString);
    }
  idx = __sbuf_malloc_handle (sizeof (char));
  va_start (ap, n);
  while (n)
    {
      next = va_arg (ap, char *);
      if (next)
	{
	  cnew = __b2c__len (next);
	  __sbuf_need_realloc (idx, length + cnew + 1 + 1);
	  memmove (__b2c__sbuffer[idx] + length, next, cnew);
	  length += cnew;
	  if (n - 1)
	    {
	      __b2c__sbuffer[idx][length] = 32;
	      length++;
	    }
	}
      n--;
    }
  va_end (ap);
  __b2c__SETLEN (__b2c__sbuffer[idx], length);
  __b2c__sbuffer[idx][length] = '\0';
  return ((char *) __b2c__sbuffer[idx]);
}

int
__b2c__lookup_by_order (__b2c__htable * name, char ***array, int size,
			int base)
{
  int i, count = 0;
  if (name)
    {
      if (*array)
	{
	  for (i = 0; i < size; i++)
	    {
	      __b2c__STRFREE ((*array)[i + base]);
	    }
	  free (*array);
	}
      *array = (char **) calloc (name->total + base, sizeof (char *));
      count = base;
      do
	{
	  for (i = 0; i < 65536; i++)
	    {
	      if (name->key[i])
		{
		  (*array)[count++] = __b2c__strdup (name->key[i]);
		}
	    }
	  name = name->next;
	}
      while (name);
      count -= base;
    }
  return (count);
}

int
__b2c__lookup_by_sort (__b2c__htable * name, char ***array, int size,
		       int base, int type, int (*compare) (const void *,
							   const void *))
{
  void **values = { NULL };
  __b2c__htable *ptr;
  int i, j, pos = 0, count = 0;
  if (name)
    {
      if (*array)
	{
	  for (i = 0; i < size; i++)
	    {
	      __b2c__STRFREE ((*array)[i + base]);
	    }
	  free (*array);
	}
      ptr = name;
      values = (void **) calloc (name->total, sizeof (char *));
      do
	{
	  for (i = 0; i < 65536; i++)
	    {
	      if (ptr->key[i])
		{
		  values[pos++] = ptr->value[i];
		}
	    }
	  ptr = ptr->next;
	}
      while (ptr);
      qsort (&values[0], pos, sizeof (void *), compare);
      *array = (char **) calloc (name->total + base, sizeof (char *));
      count = base;
      for (j = 0; j < pos; j++)
	{
	  ptr = name;
	  do
	    {
	      for (i = 0; i < 65536; i++)
		{
		  if (type ==
		      0 ? !__b2c__strcmp ((const char *) ptr->value[i],
					  (const char *) values[j]) :
		      !__b2c__memcmp (ptr->value[i], values[j]))
		    {
		      (*array)[count++] = __b2c__strdup (ptr->key[i]);
		      if (j + 1 < pos
			  && (type ==
			      0 ? !__b2c__strcmp ((const char *) values[j],
						  (const char *) values[j +
									1]) :
			      !__b2c__memcmp (values[j], values[j + 1])))
			{
			  j++;
			}
		      else
			{
			  ptr = NULL;
			  break;
			}
		    }
		}
	      if (ptr)
		{
		  ptr = ptr->next;
		}
	    }
	  while (ptr);
	}
      free (values);
      count -= base;
    }
  return (count);
}

long
__b2c__instr (int l, char *k, char *first, char *tmp, int pos)
{
  char *result;
  if (first == NULL)
    {
      return (0);
    }
  if (tmp == NULL || __b2c__len (tmp) == 0)
    {
      return (0);
    }
  if (pos <= 0)
    {
      pos = 1;
    }
  result = strstr (first + pos - 1, tmp);
  if (result == NULL)
    {
      return (0);
    }
  if (__b2c__option_utf8)
    {
      return (long) __b2c__ucs2_clen (l, k, "INSTR", first,
				      result - first + 1);
    }
  return (long) (result - first + 1);
}

char *
__b2c__left (int l, char *k, char *src, unsigned long n)
{
  unsigned long length, idx;
  if (src == NULL)
    {
      return (NULL);
    }
  length = __b2c__len (src);
  if (n >
      (__b2c__option_utf8 ? __b2c__ucs2_clen (l, k, "LEFT$", src, length) :
       length))
    {
      idx = __sbuf_malloc_handle (length + 1);
      memmove (__b2c__sbuffer[idx], src, length);
      __b2c__SETLEN (__b2c__sbuffer[idx], length);
      __b2c__sbuffer[idx][length] = '\0';
    }
  else
    {
      if (__b2c__option_utf8)
	{
	  n = __b2c__blen (l, k, "LEFT$", src, n, 0);
	}
      idx = __sbuf_malloc_handle (n + 1);
      memmove (__b2c__sbuffer[idx], src, n);
      __b2c__SETLEN (__b2c__sbuffer[idx], n);
      __b2c__sbuffer[idx][n] = '\0';
    }
  return (char *) (__b2c__sbuffer[idx]);
}

void *
__rbuf_realloc (void *__b2c__ptr, size_t __b2c__size)
{
  if (__b2c__rbuffer_length[__b2c__rbuffer_ptr] < __b2c__size)
    {
      __b2c__rbuffer_length[__b2c__rbuffer_ptr] = (size_t) __b2c__size *4;
      return (realloc
	      (__b2c__ptr, __b2c__rbuffer_length[__b2c__rbuffer_ptr]));
    }
  return (__b2c__ptr);
}

void
__sbuf_need_realloc (long idx, size_t size)
{
  if (__b2c__sbuffer[idx] == NULL)
    {
      __b2c__sbuffer[idx] =
	(char *) calloc (__b2c__BUFOFFSET + size * 2 + 1, sizeof (char));
      *(uint32_t *) (__b2c__sbuffer[idx] + 4) = size * 2 + 1;
      *(uint8_t *) (__b2c__sbuffer[idx] + 8) = 1;
      __b2c__SETRANGE (__b2c__sbuffer[idx]);
      __b2c__sbuffer[idx] += __b2c__BUFOFFSET;
    }
  else if (__b2c__buf (__b2c__sbuffer[idx]) <= size)
    {
      __b2c__sbuffer[idx] =
	(char *) realloc (__b2c__sbuffer[idx] - __b2c__BUFOFFSET,
			  __b2c__BUFOFFSET + size * 2 + 1);
      *(uint32_t *) (__b2c__sbuffer[idx] + 4) = size * 2 + 1;
      *(uint8_t *) (__b2c__sbuffer[idx] + 8) = 1;
      __b2c__SETRANGE (__b2c__sbuffer[idx]);
      __b2c__sbuffer[idx] += __b2c__BUFOFFSET;
    }
}

long
__sbuf_malloc_handle (size_t size)
{
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= __b2c__sbuffer_size)
    __b2c__sbuffer_ptr = 0;
  __sbuf_need_realloc (__b2c__sbuffer_ptr, size);
  memset (__b2c__sbuffer[__b2c__sbuffer_ptr], 0, size);
  __b2c__SETLEN (__b2c__sbuffer[__b2c__sbuffer_ptr], 0);
  return (__b2c__sbuffer_ptr);
}

char *
__b2c__strdup (const char *s)
{
  if (s == NULL)
    {
      return (NULL);
    }
  return (strdup (s));
}

char *
__b2c__strndup (const char *s, size_t n)
{
  char *cnew;
  if (s == NULL)
    {
      return (NULL);
    }
  cnew = (char *) malloc (n + 1);
  if (cnew == NULL)
    return (NULL);
  cnew[n] = '\0';
  return (char *) strncpy (cnew, s, n);
}

int
__b2c__memcmp (const void *__b2c__s1, const void *__b2c__s2)
{
  if (__b2c__s1 == NULL && __b2c__s2 == NULL)
    return (0);
  if (__b2c__s1 == NULL)
    {
      __b2c__s1 = (void *) EmptyString;
    }
  if (__b2c__s2 == NULL)
    {
      __b2c__s2 = (void *) EmptyString;
    }
  return (memcmp (__b2c__s1, __b2c__s2, sizeof (void *)));
}

int
__b2c__strcmp (const char *__b2c__s1, const char *__b2c__s2)
{
  if (__b2c__s1 == NULL && __b2c__s2 == NULL)
    return (0);
  if (__b2c__s1 == NULL)
    {
      __b2c__s1 = EmptyString;
    }
  if (__b2c__s2 == NULL)
    {
      __b2c__s2 = EmptyString;
    }
  return (strcmp (__b2c__s1, __b2c__s2));
}

int
__b2c__strcasecmp (const char *__b2c__s1, const char *__b2c__s2)
{
  if (__b2c__s1 == NULL && __b2c__s2 == NULL)
    {
      return (0);
    }
  if (__b2c__s1 == NULL)
    {
      return (-1);
    }
  if (__b2c__s2 == NULL)
    {
      return (1);
    }
  return (strcasecmp (__b2c__s1, __b2c__s2));
}

void *
__b2c_str_realloc (char *ptr, size_t size)
{
  if (ptr == NULL || __b2c__buf ((char *) ptr) <= size)
    {
      if ((long) ptr & 1)
	{
	  ptr =
	    (char *) realloc (ptr - __b2c__BUFOFFSET,
			      __b2c__BUFOFFSET + size * 2 + 1);
	}
      else
	{
	  ptr = (char *) realloc (ptr, __b2c__BUFOFFSET + size * 2 + 1);
	}
      *(uint32_t *) ((char *) ptr + 4) = size * 2 + 1;
      *(uint8_t *) ((char *) ptr + 8) = 0;
      __b2c__SETRANGE (ptr);
      ptr += __b2c__BUFOFFSET;
    }
  return (ptr);
}

char *
__b2c_Copy_String (char *x, char *y)
{
  long ylen;
  if (y == NULL)
    {
      __b2c__STRFREE (x);
      return (NULL);
    }
  else
    {
      ylen = __b2c__len (y);
    }
  x = (char *) __b2c_str_realloc (x, ylen);
  memmove (x, y, ylen);
  if ((uintptr_t) x & 1)
    {
      __b2c__SETLEN (x, ylen);
    }
  x[ylen] = '\0';
  return (x);
}

char *
__b2c_Assign_String (char **x, char *y)
{
  char *tmp;
  if (*x != NULL && y != NULL && ((uintptr_t) y & 1) && __b2c__INRANGE (y))
    {
      if (__b2c__IS_SBUF (y))
	{
	  tmp = *x;
	  *x = y;
	  __b2c__UNSETBIT (*x);
	  __b2c__sbuffer[__b2c__sbuffer_ptr] = __b2c__topstring (tmp);
	  __b2c__SETBIT (__b2c__sbuffer[__b2c__sbuffer_ptr]);
	  return (*x);
	}
    }
  return (__b2c_Copy_String (*x, y));
}

char *
__b2c__topstring (char *ptr)
{
  unsigned int len;
  if ((long) ptr & 1)
    {
      return (ptr);
    }
  len = (ptr == NULL ? 0 : strlen (ptr));
  ptr = (char *) realloc (ptr, __b2c__BUFOFFSET + len + 1);
  memset (ptr + len, 0, __b2c__BUFOFFSET + 1);
  memmove (ptr + __b2c__BUFOFFSET, ptr, len + 1);
  *(uint32_t *) (ptr) = len;
  *(uint32_t *) (ptr + 4) = len + 1;
  __b2c__SETRANGE (ptr);
  return (ptr + __b2c__BUFOFFSET);
}

unsigned long
__b2c__len (const char *ptr)
{
  if (ptr == NULL)
    {
      return (0);
    }
  if (((uintptr_t) ptr & 1) && __b2c__INRANGE (ptr) && __b2c__VALID (ptr))
    {
      return (*(uint32_t *) (ptr - __b2c__BUFOFFSET));
    }
  return ((unsigned long) strlen (ptr));
}

static inline unsigned long
__b2c__buf (const char *ptr)
{
  if (ptr == NULL)
    {
      return (0);
    }
  if (((uintptr_t) ptr & 1) && __b2c__INRANGE (ptr))
    {
      return (*(uint32_t *) (ptr - __b2c__BUFOFFSET + 4));
    }
  return ((unsigned long) strlen (ptr) + 1);
}

char *
__b2c__loop_helper (jmp_buf buf)
{
  if (__b2c__loop_result__b2c__string_var != NULL)
    {
      __b2c__SETLEN (__b2c__loop_result__b2c__string_var, 0);
      __b2c__loop_result__b2c__string_var =
	__b2c_Assign_String (&__b2c__loop_result__b2c__string_var,
			     EmptyString);
    }
  longjmp (buf, 1);
  return (NULL);
}

long
__b2c__loop_helper2 (jmp_buf buf)
{
  __b2c__loop_result = 0;
  longjmp (buf, 1);
  return (0);
}

void
__b2c__catch_signal (int sig)
{
  switch (sig)
    {
    case SIGABRT:
      fprintf (stderr,
	       "ERROR: signal ABORT received - internal error. Try to compile the program with TRAP LOCAL to find the cause.\n");
      break;
    case SIGFPE:
      fprintf (stderr,
	       "ERROR: signal for FPE received - division by zero? Examine the calculations in the program.\n");
      break;
    case SIGSEGV:
      fprintf (stderr,
	       "ERROR: signal for SEGMENTATION FAULT received - memory invalid or array out of bounds? Try to compile the program with TRAP LOCAL to find the cause.\n");
      break;
    case SIGILL:
      fprintf (stderr,
	       "ERROR: signal for ILLEGAL INSTRUCTION received - executing the program on other hardware? Try to recompile the program from scratch.\n");
      break;
    }
  exit (sig);
}

void
__b2c__segv (int sig)
{
  longjmp (__b2c__jump, 1);
}

int
__b2c__memory__check (volatile char *x, int size)
{
  int i, illegal = 0;
  void (*handler) (int);
  handler = signal (SIGSEGV, __b2c__segv);
  if (!setjmp (__b2c__jump))
    {
      for (i = 0; i < size; i++)
	if (*(x + i))
	  continue;
    }
  else
    illegal = 1;
  if (__b2c__trap)
    signal (SIGSEGV, __b2c__catch_signal);
  else
    signal (SIGSEGV, handler);
  return (illegal);
}

char *
__b2c__mid (int l, char *k, char *src, long pos, long length)
{
  long idx, src_len;
  if (src == NULL)
    {
      return (EmptyString);
    }
  src_len = __b2c__len (src);
  pos -= 1;
  if (pos < 0)
    {
      pos =
	(__b2c__option_utf8 ? __b2c__ucs2_clen (l, k, "MID$", src, src_len) :
	 src_len) + 1 + pos;
    }
  if (__b2c__option_utf8)
    {
      pos = __b2c__blen (l, k, "MID$", src, pos, 0);
    }
  if (pos > src_len)
    {
      return (EmptyString);
    }
  if (__b2c__option_utf8 && length >= 0)
    {
      length = __b2c__blen (l, k, "MID$", src + pos, length, 0);
    }
  if (length < 0 || pos + length > src_len)
    {
      length = src_len - pos;
    }
  idx = __sbuf_malloc_handle (length + 1);
  memmove (__b2c__sbuffer[idx], src + pos, length);
  __b2c__SETLEN (__b2c__sbuffer[idx], length);
  __b2c__sbuffer[idx][length] = '\0';
  return (char *) (__b2c__sbuffer[idx]);
}

char *
__b2c__min_str (char *x, char *y)
{
  if (strcmp (x, y) < 0)
    {
      return (x);
    }
  return (y);
}

char *
__b2c__max_str (char *x, char *y)
{
  if (strcmp (x, y) > 0)
    {
      return (x);
    }
  return (y);
}

char *
__b2c__os (int l, char *k)
{
  struct utsname buf;
  long idx;
  idx = __sbuf_malloc_handle (512 * sizeof (char));
  if (uname (&buf) < 0 && __b2c__trap)
    {
      ERROR = 26;
      RUNTIMEFERR ("OS$", ERROR, k, l);
    }
  strcpy (__b2c__sbuffer[idx], buf.sysname);
  strcat (__b2c__sbuffer[idx], " ");
  strcat (__b2c__sbuffer[idx], buf.machine);
  __b2c__SETLEN (__b2c__sbuffer[idx], strlen (__b2c__sbuffer[idx]));
  return (char *) (__b2c__sbuffer[idx]);
}

char *
__b2c__right (int l, char *k, char *src, unsigned long n)
{
  unsigned long length, idx;
  if (src == NULL)
    {
      return (NULL);
    }
  length = __b2c__len (src);
  if (n >
      (__b2c__option_utf8 ? __b2c__ucs2_clen (l, k, "RIGHT$", src, length) :
       length))
    {
      idx = __sbuf_malloc_handle (length + 1);
      memmove (__b2c__sbuffer[idx], src, length);
      __b2c__SETLEN (__b2c__sbuffer[idx], length);
      __b2c__sbuffer[idx][length] = '\0';
    }
  else
    {
      if (__b2c__option_utf8)
	{
	  n = __b2c__blen (l, k, "RIGHT$", src, n, 1);
	}
      idx = __sbuf_malloc_handle (n + 1);
      memmove (__b2c__sbuffer[idx], src + length - n, n);
      __b2c__SETLEN (__b2c__sbuffer[idx], n);
      __b2c__sbuffer[idx][n] = '\0';
    }
  return (char *) (__b2c__sbuffer[idx]);
}

int
__b2c__sortnrd (const void *a, const void *b)
{
  if (*(double *) a == *(double *) b)
    return (0);
  else if (*(double *) a < *(double *) b)
    return (-1);
  else
    return (1);
}

int
__b2c__sortnrd_wrap (const void *a, const void *b)
{
  return (__b2c__sortnrd (*(void **) a, *(void **) b));
}

int
__b2c__sortnrd_down (const void *a, const void *b)
{
  if (*(double *) a == *(double *) b)
    return (0);
  else if (*(double *) a < *(double *) b)
    return (1);
  else
    return (-1);
}

int
__b2c__sortnrd_wrap_down (const void *a, const void *b)
{
  return (__b2c__sortnrd_down (*(void **) a, *(void **) b));
}

int
__b2c__sortnrf (const void *a, const void *b)
{
  if (*(float *) a == *(float *) b)
    return (0);
  else if (*(float *) a < *(float *) b)
    return (-1);
  else
    return (1);
}

int
__b2c__sortnrf_wrap (const void *a, const void *b)
{
  return (__b2c__sortnrf (*(void **) a, *(void **) b));
}

int
__b2c__sortnrf_down (const void *a, const void *b)
{
  if (*(float *) a == *(float *) b)
    return (0);
  else if (*(float *) a < *(float *) b)
    return (1);
  else
    return (-1);
}

int
__b2c__sortnrf_wrap_down (const void *a, const void *b)
{
  return (__b2c__sortnrf_down (*(void **) a, *(void **) b));
}

int
__b2c__sortnrl (const void *a, const void *b)
{
  if (*(long *) a == *(long *) b)
    return (0);
  else if (*(long *) a < *(long *) b)
    return (-1);
  else
    return (1);
}

int
__b2c__sortnrl_wrap (const void *a, const void *b)
{
  return (__b2c__sortnrl (*(void **) a, *(void **) b));
}

int
__b2c__sortnrl_down (const void *a, const void *b)
{
  if (*(long *) a == *(long *) b)
    return (0);
  else if (*(long *) a < *(long *) b)
    return (1);
  else
    return (-1);
}

int
__b2c__sortnrl_wrap_down (const void *a, const void *b)
{
  return (__b2c__sortnrl_down (*(void **) a, *(void **) b));
}

int
__b2c__sortnri (const void *a, const void *b)
{
  if (*(int *) a == *(int *) b)
    return (0);
  else if (*(int *) a < *(int *) b)
    return (-1);
  else
    return (1);
}

int
__b2c__sortnri_wrap (const void *a, const void *b)
{
  return (__b2c__sortnri (*(void **) a, *(void **) b));
}

int
__b2c__sortnri_down (const void *a, const void *b)
{
  if (*(int *) a == *(int *) b)
    return (0);
  else if (*(int *) a < *(int *) b)
    return (1);
  else
    return (-1);
}

int
__b2c__sortnri_wrap_down (const void *a, const void *b)
{
  return (__b2c__sortnri_down (*(void **) a, *(void **) b));
}

int
__b2c__sortnrs (const void *a, const void *b)
{
  if (*(short *) a == *(short *) b)
    return (0);
  else if (*(short *) a < *(short *) b)
    return (-1);
  else
    return (1);
}

int
__b2c__sortnrs_wrap (const void *a, const void *b)
{
  return (__b2c__sortnrs (*(void **) a, *(void **) b));
}

int
__b2c__sortnrs_down (const void *a, const void *b)
{
  if (*(short *) a == *(short *) b)
    return (0);
  else if (*(short *) a < *(short *) b)
    return (1);
  else
    return (-1);
}

int
__b2c__sortnrs_wrap_down (const void *a, const void *b)
{
  return (__b2c__sortnrs_down (*(void **) a, *(void **) b));
}

int
__b2c__sortnrc (const void *a, const void *b)
{
  if (*(char *) a == *(char *) b)
    return (0);
  else if (*(char *) a < *(char *) b)
    return (-1);
  else
    return (1);
}

int
__b2c__sortnrc_wrap (const void *a, const void *b)
{
  return (__b2c__sortnrc (*(void **) a, *(void **) b));
}

int
__b2c__sortnrc_down (const void *a, const void *b)
{
  if (*(char *) a == *(char *) b)
    return (0);
  else if (*(char *) a < *(char *) b)
    return (1);
  else
    return (-1);
}

int
__b2c__sortnrc_wrap_down (const void *a, const void *b)
{
  return (__b2c__sortnrc_down (*(void **) a, *(void **) b));
}

int
__b2c__sortstr (const void *__b2c__a, const void *__b2c__b)
{
  if (*(char **) __b2c__a == NULL)
    return (-1);
  if (*(char **) __b2c__b == NULL)
    return (1);
  return strcmp (*(char **) __b2c__a, *(char **) __b2c__b);
}

int
__b2c__sortstr_down (const void *__b2c__a, const void *__b2c__b)
{
  if (*(char **) __b2c__a == NULL)
    return (-1);
  if (*(char **) __b2c__b == NULL)
    return (1);
  return strcmp (*(char **) __b2c__b, *(char **) __b2c__a);
}

char *
__b2c__str (double nr)
{
  long idx;
  int len;
  idx = __sbuf_malloc_handle (32);
  if (floor (nr) == nr)
    {
      len = snprintf (__b2c__sbuffer[idx], 32, "%ld", (long) nr);
    }
  else
    {
      len = snprintf (__b2c__sbuffer[idx], 32, "%g", (double) nr);
    } __b2c__SETLEN (__b2c__sbuffer[idx], len);
  __b2c__sbuffer[idx][len] = '\0';
  return (char *) (__b2c__sbuffer[idx]);
}

long
__b2c__delim_engine (int type, long *returned_value, char *string,
		     char *delim, long nr)
{
  long x, len, cnt = 0, start = 0;
  int in_string = 0, is_escaped = 0;
  if (delim == NULL)
    {
      delim = __b2c__option_delim;
    }
  len = __b2c__len (delim);
  for (x = 0; string != NULL && string[x] != 0; x++)
    {
      if (!in_string)
	{
	  if (string[x] == delim[0])
	    {
	      if (!strncmp (string + x, delim, len))
		{
		  if (__b2c__collapse == 0)
		    {
		      cnt++;
		    }
		  else if (x + len - start > len)
		    {
		      cnt++;
		    }
		  if (nr && nr == cnt)
		    {
		      break;
		    }
		  else
		    {
		      start = x + len;
		    }
		}
	    }
	}
      if (string[x] == 92)
	{
	  if (!is_escaped)
	    {
	      is_escaped = 1;
	    }
	  else
	    {
	      is_escaped = 0;
	    }
	}
      else if (string[x] == __b2c__option_dq)
	{
	  if (!is_escaped && __b2c__option_quoted)
	    {
	      in_string = 1 - in_string;
	    }
	  is_escaped = 0;
	}
      else
	{
	  is_escaped = 0;
	}
    }
  switch (type)
    {
    case 1:
      if (nr - cnt > 1)
	{
	  *returned_value = 0;
	}
      else
	{
	  *returned_value = x - start;
	}
      break;
    case 2:
      if (x == 0)
	{
	  *returned_value = 0;
	}
      else
	{
	  if (__b2c__collapse == 0)
	    {
	      cnt++;
	    }
	  else if (x + len - start > len)
	    {
	      cnt++;
	    }
	  *returned_value = cnt;
	}
      break;
    default:
      *returned_value = 0;
    }
  return (start);
}

int
__b2c_utf8_conv (int txt, char *utf8)
{
  unsigned char b1, b2, b3;
  int len;
  if (txt > 0xFFFF)
    {
      b1 = txt & 0x0000FF;
      b2 = (txt & 0x00FF00) >> 8;
      b3 = (txt & 0xFF0000) >> 16;
      len =
	snprintf (utf8, 5, "%c%c%c%c", 0xF0 | (b3 >> 2),
		  0x80 | ((b3 & 0x03) << 4) | ((b2 & 0xF0) >> 4),
		  0x80 | ((b2 & 0x0F) << 2) | ((b1 & 0xC0) >> 6),
		  0x80 | (b1 & 0x3F));
    }
  else if (txt > 0x07FF)
    {
      b1 = txt & 0x00FF;
      b2 = (txt & 0xFF00) >> 8;
      len = snprintf (utf8, 4, "%c%c%c", 0xE0 | ((b2 & 0xF0) >> 4),
		      0x80 | ((b2 & 0x0F) << 2) | ((b1 & 0xC0) >> 6),
		      0x80 | (b1 & 0x3F));
    }
  else if (txt > 0x007F)
    {
      b1 = txt & 0x00FF;
      b2 = (txt & 0xFF00) >> 8;
      len = snprintf (utf8, 3, "%c%c",
		      0xC0 | (b2 << 2) | ((b1 & 0xC0) >> 6),
		      0x80 | (b1 & 0x3F));
    }
  else
    {
      len = snprintf (utf8, 2, "%c", txt & 0x7F);
    }
  return (len);
}

unsigned long
__b2c__ulen (int l, char *k, char *func, ...)
{
  int pos;
  long len = 0;
  char *ptr;
  va_list ap;
  va_start (ap, func);
  ptr = va_arg (ap, char *);
  pos = va_arg (ap, int);
  va_end (ap);
  if (ptr == NULL)
    {
      return (0);
    }
  if (pos < 0)
    {
      while (*ptr)
	{
	  if ((*ptr & 0xF0) == 0xF0)
	    {
	      len++;
	      ptr += 4;
	    }
	  else if ((*ptr & 0xE0) == 0xE0)
	    {
	      len++;
	      ptr += 3;
	    }
	  else if ((*ptr & 0xC0) == 0xC0)
	    {
	      len++;
	      ptr += 2;
	    }
	  else if ((*ptr & 0x80) == 0)
	    {
	      len++;
	      ptr++;
	    }
	  else
	    {
	      ERROR = 38;
	      RUNTIMEFERR (func, ERROR, k, l);
	    }
	}
    }
  else
    {
      len = __b2c__ucs2_clen (l, k, "ULEN", ptr, pos);
    }
  return (len);
}

unsigned long
__b2c__blen (int l, char *k, char *func, char *ptr, long c, ...)
{
  va_list ap;
  char *org = ptr;
  int flag;
  if (ptr == NULL)
    {
      return (0);
    }
  va_start (ap, c);
  flag = va_arg (ap, int);
  va_end (ap);
  if (flag)
    {
      c = __b2c__ulen (l, k, "BYTELEN", org, -1) - c;
    }
  while (*ptr && c > 0)
    {
      if ((*ptr & 0xF0) == 0xF0)
	{
	  ptr += 4;
	}
      else if ((*ptr & 0xE0) == 0xE0)
	{
	  ptr += 3;
	}
      else if ((*ptr & 0xC0) == 0xC0)
	{
	  ptr += 2;
	}
      else if ((*ptr & 0x80) == 0)
	{
	  ptr++;
	}
      else
	{
	  ERROR = 38;
	  fprintf (stderr, "Cannot decode UTF-8 string: '%s'\n", org);
	  RUNTIMEFERR (func, ERROR, k, l);
	}
      c--;
    }
  if (flag)
    {
      return (__b2c__len (org) - (ptr - org));
    }
  else
    {
      return (ptr - org);
    }
}

unsigned long
__b2c__ucs2_clen (int l, char *k, char *func, char *ptr, int c)
{
  int len = 0;
  char *org;
  if (ptr == NULL)
    return (0);
  org = ptr;
  while (*ptr && c > 0)
    {
      if ((*ptr & 0xF0) == 0xF0)
	{
	  ptr += 4;
	  c -= 4;
	}
      else if ((*ptr & 0xE0) == 0xE0)
	{
	  ptr += 3;
	  c -= 3;
	}
      else if ((*ptr & 0xC0) == 0xC0)
	{
	  ptr += 2;
	  c -= 2;
	}
      else if ((*ptr & 0x80) == 0)
	{
	  ptr++;
	  c--;
	}
      else
	{
	  ERROR = 38;
	  fprintf (stderr, "Cannot decode UTF-8 string: '%s'\n", org);
	  RUNTIMEFERR (func, ERROR, k, l);
	}
      len++;
    }
  return (len);
}

char *
__b2c__extract (int l, char *k, char *src, char *needle, int flag)
{
  int reti, len, pos = 0;
  char *tmp;
  regex_t regex;
  char __b2c__buf[100];
  regmatch_t where[1];
  long idx;
  if (src == NULL || needle == NULL)
    {
      return (src);
    }
  if (__b2c__len (src) == 0 || __b2c__len (needle) == 0)
    {
      return (src);
    }
  idx = __sbuf_malloc_handle (__b2c__len (src) + 1);
  if (flag > 0)
    {
      if (__b2c__option_compare == 0)
	reti = regcomp (&regex, needle, REG_EXTENDED);
      else
	reti = regcomp (&regex, needle, REG_EXTENDED | REG_ICASE);
      if (__b2c__trap && reti)
	{
	  ERROR = 27;
	  regerror (reti, &regex, __b2c__buf, sizeof (__b2c__buf));
	  fprintf (stderr, "%s\n", __b2c__buf);
	  RUNTIMEFERR ("EXTRACT$", ERROR, k, l);
	}
      while ((reti = regexec (&regex, src, 1, where, 0)) == 0)
	{
	  memcpy (__b2c__sbuffer[idx] + pos, src, (size_t) where[0].rm_so);
	  pos += where[0].rm_so;
	  src += (long) where[0].rm_eo;
	}
      regfree (&regex);
      len = strlen (src);
      memcpy (__b2c__sbuffer[idx] + pos, src, len);
      pos += len;
    }
  else
    {
      while ((tmp = strstr (src, needle)) != NULL)
	{
	  memcpy (__b2c__sbuffer[idx] + pos, src, (size_t) (tmp - src));
	  pos += tmp - src;
	  src = tmp + __b2c__len (needle);
	}
      len = strlen (src);
      memcpy (__b2c__sbuffer[idx] + pos, src, len);
      pos += len;
    }
  __b2c__SETLEN (__b2c__sbuffer[idx], pos);
  __b2c__sbuffer[idx][pos] = '\0';
  return (char *) (__b2c__sbuffer[idx]);
}

long
__b2c__regex (int l, char *k, char *x, char *y)
{
  regex_t reg;
  int reti;
  char buf[100];
  regmatch_t where[1];
  if (x == NULL || y == NULL)
    return (0);
  if (__b2c__option_compare == 0)
    reti = regcomp (&reg, y, REG_EXTENDED);
  else
    reti = regcomp (&reg, y, REG_EXTENDED | REG_ICASE);
  if (__b2c__trap && reti)
    {
      ERROR = 27;
      regerror (reti, &reg, buf, sizeof (buf));
      fprintf (stderr, "%s\n", buf);
      RUNTIMEFERR ("REGEX", ERROR, k, l);
    }
  reti = regexec (&reg, x, 1, where, 0);
  regfree (&reg);
  if (!reti)
    {
      REGLEN = where[0].rm_eo - where[0].rm_so;
      return (where[0].rm_so + 1);
    }
  else
    {
      REGLEN = 0;
      return (0);
    }
}

char *
__b2c__replace (int l, char *k, char *haystack, char *needle, char *replace,
		int flag)
{
  char *tmp;
  long replen, hstlen, ndllen, length = 0;
  regex_t regex;
  int i, reti;
  long idx;
  char buf[100];
  regmatch_t where[1];
  if (haystack == NULL || needle == NULL)
    {
      return (haystack);
    }
  if (replace == NULL)
    {
      replace = EmptyString;
    }
  ndllen = __b2c__len (needle);
  hstlen = __b2c__len (haystack);
  if (hstlen == 0 || ndllen == 0)
    {
      return (haystack);
    }
  if (flag == 2)
    {
      idx = __sbuf_malloc_handle (hstlen + 1);
      strncpy (__b2c__sbuffer[idx], haystack, hstlen);
      for (i = 0; i < hstlen; i++)
	{
	  if ((tmp = strchr (needle, __b2c__sbuffer[idx][i])) != NULL)
	    {
	      __b2c__sbuffer[idx][i] = replace[tmp - needle];
	    }
	}
      __b2c__SETLEN (__b2c__sbuffer[idx], i);
      __b2c__sbuffer[idx][i] = '\0';
      return (char *) (__b2c__sbuffer[idx]);
    }
  idx = __sbuf_malloc_handle (sizeof (char));
  __b2c__sbuffer[idx][0] = '\0';
  replen = __b2c__len (replace);
  if (flag == 1)
    {
      if (__b2c__option_compare == 0)
	reti = regcomp (&regex, needle, REG_EXTENDED);
      else
	reti = regcomp (&regex, needle, REG_EXTENDED | REG_ICASE);
      if (__b2c__trap && reti)
	{
	  ERROR = 27;
	  regerror (reti, &regex, buf, sizeof (buf));
	  fprintf (stderr, "%s\n", buf);
	  RUNTIMEFERR ("REPLACE$", ERROR, k, l);
	}
      while ((reti = regexec (&regex, haystack, 1, where, 0)) == 0)
	{
	  __sbuf_need_realloc (idx, length + where[0].rm_so + replen + 1);
	  memcpy (__b2c__sbuffer[idx] + length, haystack,
		  (size_t) where[0].rm_so);
	  length += where[0].rm_so;
	  memcpy (__b2c__sbuffer[idx] + length, replace, replen);
	  length += replen;
	  haystack += (long) where[0].rm_eo;
	} regfree (&regex);
    }
  else
    {
      while ((tmp = strstr (haystack, needle)) != NULL)
	{
	  __sbuf_need_realloc (idx, length + tmp - haystack + replen + 1);
	  memcpy (__b2c__sbuffer[idx] + length, haystack,
		  (size_t) (tmp - haystack));
	  length += tmp - haystack;
	  memcpy (__b2c__sbuffer[idx] + length, replace, replen);
	  length += replen;
	  haystack = tmp + ndllen;
    }} hstlen = strlen (haystack);
  __sbuf_need_realloc (idx, length + hstlen + 1);
  memcpy (__b2c__sbuffer[idx] + length, haystack, hstlen);
  length += hstlen;
  __b2c__SETLEN (__b2c__sbuffer[idx], length);
  __b2c__sbuffer[idx][length] = '\0';
  return (char *) (__b2c__sbuffer[idx]);
}
